package com.github.snowdream.android.widget;

import android.content.Context;
import android.graphics.Bitmap;

public class BitmapImage extends SmartImage {
    private Bitmap bitmap;

    public BitmapImage(Bitmap bitmap) {
        this.bitmap = bitmap;
    }
    
    public BitmapImage(Bitmap bitmap,int width, int height) {
        super(width,height);
        this.bitmap = bitmap;
    }
    
    public Bitmap getBitmap(Context context) {
        super.getBitmap(context);
        
        String key = this.bitmap.hashCode()+"";

        // Try getting bitmap from cache first
        Bitmap bitmap = null;
        if(key != null) {
            bitmap = smartImageCache.get(key);
            if(bitmap == null) {
                bitmap = getBitmapFromBitmap(this.bitmap);
                if(bitmap != null){
                    smartImageCache.put(key, bitmap);
                }
            }
        }

        return bitmap;
    }
    
    private Bitmap getBitmapFromBitmap(Bitmap bitmap) {
        if (width == 0 && height == 0){
            return bitmap;
        }
        
        Bitmap tempBitmap = null;
        
        try {
            tempBitmap = Bitmap.createScaledBitmap(bitmap, width, height, false);
        } catch (Exception e) {
            e.printStackTrace();
        }finally{
            if (tempBitmap == null) {
                width = 0;
                height = 0;
            }else {
                width = tempBitmap.getWidth();
                height = tempBitmap.getHeight();
            }
        }
        
        return tempBitmap;
    }
    
    public void cancel(){
        super.cancel();
    }
}