package com.github.snowdream.android.widget;

import android.content.Context;
import android.graphics.Bitmap;

import java.io.InputStream;

public abstract class SmartImage {
    protected static SmartImageCache smartImageCache;

    protected int width = 0;
    protected int height = 0;
    protected boolean cancel = false;
    
    public SmartImage(){};
    
    public SmartImage(int width, int height){
        this.width = width;
        this.height = height;
    };
    
    public Bitmap getBitmap(Context context){
        // Don't leak context
        if(smartImageCache == null) {
            smartImageCache = new SmartImageCache(context);
        }
        
        return null;
    }
    
    protected Bitmap getBitmapFromInputStream(InputStream is, int width, int height){
        return BitmapUtils.getBitmapFromInputStream(is, width, height);
    }

    public void cancel(){
        cancel = true;
    }
    
    public static void removeFromCache(String key) {
        if(smartImageCache != null) {
            smartImageCache.remove(key);
        }
    }
}